require 'helper'
require 'fluent/test/driver/filter'
require 'fluent/plugin/filter_split_string'

class SplitStringFilterTest < Test::Unit::TestCase
  include Fluent

  def setup
    Fluent::Test.setup
  end

  def create_driver
    Fluent::Test::Driver::Filter.new(Fluent::Plugin::SplitStringFilter).configure("")
  end

  def test_emit
    driver = create_driver()
    event_stream = Fluent::MultiEventStream.new

    time = event_time("2014-04-17 07:28:49 UTC")
    event_stream.add(time, {"some" => "key", "message" => 'a\nb\nc\n'})

    driver.run(default_tag: "test.info") do
      driver.feed(event_stream)
    end
    records = driver.filtered_records

    assert_equal 3, records.length
    assert_equal({"some" => "key", "message" => "a"}, records[0])
    assert_equal({"some" => "key", "message" => "b"}, records[1])
    assert_equal({"some" => "key", "message" => "c"}, records[2])
  end
end
